unit AFMUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AlfaFile, StdCtrls;

type
  TForm1 = class(TForm)
    AFM: TAlfaFileMonitor;
    LB: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure AFMCreate(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMDelete(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMClose(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMOpen(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMRename(Sender: TObject; const szProcess, szFileName,
      szDestFileName: String);
    procedure AFMFlush(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMSetAttr(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMWrite(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMRead(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMGetAttr(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailGetAttr(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailRead(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailWrite(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailSetAttr(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailRename(Sender: TObject; const szProcess, szFileName,
      szDestFileName: String);
    procedure AFMFailOpen(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailFlush(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailDelete(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailCreate(Sender: TObject; const szProcess,
      szFileName: String);
    procedure AFMFailClose(Sender: TObject; const szProcess,
      szFileName: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 AFM.CaptureReadEvents := True;
 AFM.Start;
// To make sure filenames can fir in list box
 SendMessage(LB.Handle, LB_SETHORIZONTALEXTENT,
             Screen.Width, 0);
 LB.Items.Add('Initialization result is ' + IntToStr(AFM.Error));
end;

procedure TForm1.AFMCreate(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File CREATED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMDelete(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File DELETED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMClose(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File CLOSED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMOpen(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File OPENED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMRename(Sender: TObject; const szProcess, szFileName,
  szDestFileName: String);
begin
 LB.Items.Add('File RENAMED ' + szFileName + ' to '+
              szDestFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFlush(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File FLUSHED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMSetAttr(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File ATTRIBUTES CHANGED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMWrite(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add(szProcess + ' wrote to file ' + szFileName);
end;

procedure TForm1.AFMRead(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add(szProcess + ' read from file ' + szFileName);
end;

procedure TForm1.AFMGetAttr(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('File ATTRIBUTES QUERIED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailGetAttr(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File ATTRIBUTES QUERIED ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailRead(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add(szProcess + ' FAILED to read from file ' + szFileName);
end;

procedure TForm1.AFMFailWrite(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add(szProcess + ' FAILED to write to file ' + szFileName);
end;

procedure TForm1.AFMFailSetAttr(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File ATTRIBUTES CHANGE ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailRename(Sender: TObject; const szProcess,
  szFileName, szDestFileName: String);
begin
 LB.Items.Add('FAILED : File RENAME ' + szFileName + ' to '+
              szDestFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailOpen(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File OPEN ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailFlush(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File FLUSH ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailDelete(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File DELETE ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailCreate(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File CREATE ' + szFileName + ' by process ' +
              szProcess);
end;

procedure TForm1.AFMFailClose(Sender: TObject; const szProcess,
  szFileName: String);
begin
 LB.Items.Add('FAILED : File CLOSE ' + szFileName + ' by process ' +
              szProcess);
end;

end.
